<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCheckinTarget ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCheckinTarget
 * @subpackage Arrays
 */
class ArrayOfCheckinTarget extends AbstractStructArrayBase
{
    /**
     * The CheckinTarget
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CheckinTarget[]
     */
    public $CheckinTarget;
    /**
     * Constructor method for ArrayOfCheckinTarget
     * @uses ArrayOfCheckinTarget::setCheckinTarget()
     * @param \App|C\StructType\CheckinTarget[] $checkinTarget
     */
    public function __construct(array $checkinTarget = array())
    {
        $this
            ->setCheckinTarget($checkinTarget);
    }
    /**
     * Get CheckinTarget value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CheckinTarget[]|null
     */
    public function getCheckinTarget()
    {
        return isset($this->CheckinTarget) ? $this->CheckinTarget : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCheckinTarget method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCheckinTarget method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCheckinTargetForArrayConstraintsFromSetCheckinTarget(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCheckinTargetCheckinTargetItem) {
            // validation for constraint: itemType
            if (!$arrayOfCheckinTargetCheckinTargetItem instanceof \App|C\StructType\CheckinTarget) {
                $invalidValues[] = is_object($arrayOfCheckinTargetCheckinTargetItem) ? get_class($arrayOfCheckinTargetCheckinTargetItem) : sprintf('%s(%s)', gettype($arrayOfCheckinTargetCheckinTargetItem), var_export($arrayOfCheckinTargetCheckinTargetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CheckinTarget property can only contain items of type \App|C\StructType\CheckinTarget, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CheckinTarget value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CheckinTarget[] $checkinTarget
     * @return \App|C\ArrayType\ArrayOfCheckinTarget
     */
    public function setCheckinTarget(array $checkinTarget = array())
    {
        // validation for constraint: array
        if ('' !== ($checkinTargetArrayErrorMessage = self::validateCheckinTargetForArrayConstraintsFromSetCheckinTarget($checkinTarget))) {
            throw new \InvalidArgumentException($checkinTargetArrayErrorMessage, __LINE__);
        }
        if (is_null($checkinTarget) || (is_array($checkinTarget) && empty($checkinTarget))) {
            unset($this->CheckinTarget);
        } else {
            $this->CheckinTarget = $checkinTarget;
        }
        return $this;
    }
    /**
     * Add item to CheckinTarget value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CheckinTarget $item
     * @return \App|C\ArrayType\ArrayOfCheckinTarget
     */
    public function addToCheckinTarget(\App|C\StructType\CheckinTarget $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\CheckinTarget) {
            throw new \InvalidArgumentException(sprintf('The CheckinTarget property can only contain items of type \App|C\StructType\CheckinTarget, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CheckinTarget[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\CheckinTarget|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\CheckinTarget|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\CheckinTarget|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\CheckinTarget|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\CheckinTarget|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CheckinTarget
     */
    public function getAttributeName()
    {
        return 'CheckinTarget';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfCheckinTarget
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
