<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvalidDataError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInvalidDataError
 * @subpackage Arrays
 */
class ArrayOfInvalidDataError extends AbstractStructArrayBase
{
    /**
     * The InvalidDataError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\InvalidDataError[]
     */
    public $InvalidDataError;
    /**
     * Constructor method for ArrayOfInvalidDataError
     * @uses ArrayOfInvalidDataError::setInvalidDataError()
     * @param \App|C\StructType\InvalidDataError[] $invalidDataError
     */
    public function __construct(array $invalidDataError = array())
    {
        $this
            ->setInvalidDataError($invalidDataError);
    }
    /**
     * Get InvalidDataError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\InvalidDataError[]|null
     */
    public function getInvalidDataError()
    {
        return isset($this->InvalidDataError) ? $this->InvalidDataError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvalidDataError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvalidDataError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvalidDataErrorForArrayConstraintsFromSetInvalidDataError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvalidDataErrorInvalidDataErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvalidDataErrorInvalidDataErrorItem instanceof \App|C\StructType\InvalidDataError) {
                $invalidValues[] = is_object($arrayOfInvalidDataErrorInvalidDataErrorItem) ? get_class($arrayOfInvalidDataErrorInvalidDataErrorItem) : sprintf('%s(%s)', gettype($arrayOfInvalidDataErrorInvalidDataErrorItem), var_export($arrayOfInvalidDataErrorInvalidDataErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvalidDataError property can only contain items of type \App|C\StructType\InvalidDataError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvalidDataError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\InvalidDataError[] $invalidDataError
     * @return \App|C\ArrayType\ArrayOfInvalidDataError
     */
    public function setInvalidDataError(array $invalidDataError = array())
    {
        // validation for constraint: array
        if ('' !== ($invalidDataErrorArrayErrorMessage = self::validateInvalidDataErrorForArrayConstraintsFromSetInvalidDataError($invalidDataError))) {
            throw new \InvalidArgumentException($invalidDataErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($invalidDataError) || (is_array($invalidDataError) && empty($invalidDataError))) {
            unset($this->InvalidDataError);
        } else {
            $this->InvalidDataError = $invalidDataError;
        }
        return $this;
    }
    /**
     * Add item to InvalidDataError value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\InvalidDataError $item
     * @return \App|C\ArrayType\ArrayOfInvalidDataError
     */
    public function addToInvalidDataError(\App|C\StructType\InvalidDataError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\InvalidDataError) {
            throw new \InvalidArgumentException(sprintf('The InvalidDataError property can only contain items of type \App|C\StructType\InvalidDataError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvalidDataError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\InvalidDataError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\InvalidDataError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\InvalidDataError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\InvalidDataError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\InvalidDataError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvalidDataError
     */
    public function getAttributeName()
    {
        return 'InvalidDataError';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfInvalidDataError
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
