<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Booking StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Booking
 * @subpackage Structs
 */
class Booking extends PassengerNameRecord
{
    /**
     * The FareInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfoBooking
     */
    public $FareInfo;
    /**
     * The MiscInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\MiscInfo
     */
    public $MiscInfo;
    /**
     * The TicketInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\TicketInfo
     */
    public $TicketInfo;
    /**
     * Constructor method for Booking
     * @uses Booking::setFareInfo()
     * @uses Booking::setMiscInfo()
     * @uses Booking::setTicketInfo()
     * @param \App|C\StructType\FareInfoBooking $fareInfo
     * @param \App|C\StructType\MiscInfo $miscInfo
     * @param \App|C\StructType\TicketInfo $ticketInfo
     */
    public function __construct(\App|C\StructType\FareInfoBooking $fareInfo = null, \App|C\StructType\MiscInfo $miscInfo = null, \App|C\StructType\TicketInfo $ticketInfo = null)
    {
        $this
            ->setFareInfo($fareInfo)
            ->setMiscInfo($miscInfo)
            ->setTicketInfo($ticketInfo);
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfoBooking|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfoBooking $fareInfo
     * @return \App|C\StructType\Booking
     */
    public function setFareInfo(\App|C\StructType\FareInfoBooking $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get MiscInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\MiscInfo|null
     */
    public function getMiscInfo()
    {
        return isset($this->MiscInfo) ? $this->MiscInfo : null;
    }
    /**
     * Set MiscInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\MiscInfo $miscInfo
     * @return \App|C\StructType\Booking
     */
    public function setMiscInfo(\App|C\StructType\MiscInfo $miscInfo = null)
    {
        if (is_null($miscInfo) || (is_array($miscInfo) && empty($miscInfo))) {
            unset($this->MiscInfo);
        } else {
            $this->MiscInfo = $miscInfo;
        }
        return $this;
    }
    /**
     * Get TicketInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\TicketInfo|null
     */
    public function getTicketInfo()
    {
        return isset($this->TicketInfo) ? $this->TicketInfo : null;
    }
    /**
     * Set TicketInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\TicketInfo $ticketInfo
     * @return \App|C\StructType\Booking
     */
    public function setTicketInfo(\App|C\StructType\TicketInfo $ticketInfo = null)
    {
        if (is_null($ticketInfo) || (is_array($ticketInfo) && empty($ticketInfo))) {
            unset($this->TicketInfo);
        } else {
            $this->TicketInfo = $ticketInfo;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\Booking
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
