<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelSegmentSettings StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CancelSegmentSettings
 * @subpackage Structs
 */
class CancelSegmentSettings extends ApiObject
{
    /**
     * The SegmentReferencesToCancel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring
     */
    public $SegmentReferencesToCancel;
    /**
     * Constructor method for CancelSegmentSettings
     * @uses CancelSegmentSettings::setSegmentReferencesToCancel()
     * @param \App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel
     */
    public function __construct(\App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel = null)
    {
        $this
            ->setSegmentReferencesToCancel($segmentReferencesToCancel);
    }
    /**
     * Get SegmentReferencesToCancel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring|null
     */
    public function getSegmentReferencesToCancel()
    {
        return isset($this->SegmentReferencesToCancel) ? $this->SegmentReferencesToCancel : null;
    }
    /**
     * Set SegmentReferencesToCancel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel
     * @return \App|C\StructType\CancelSegmentSettings
     */
    public function setSegmentReferencesToCancel(\App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel = null)
    {
        if (is_null($segmentReferencesToCancel) || (is_array($segmentReferencesToCancel) && empty($segmentReferencesToCancel))) {
            unset($this->SegmentReferencesToCancel);
        } else {
            $this->SegmentReferencesToCancel = $segmentReferencesToCancel;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\CancelSegmentSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
