<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareRule
 * @subpackage Structs
 */
class FareRule extends ApiObject
{
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareRuleDetails
     */
    public $Details;
    /**
     * The FareConditionText
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareConditionText
     */
    public $FareConditionText;
    /**
     * The Ref
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ref;
    /**
     * The VoluntaryChangeCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VoluntaryChangeCode;
    /**
     * The VoluntaryRefundCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VoluntaryRefundCode;
    /**
     * Constructor method for FareRule
     * @uses FareRule::setDetails()
     * @uses FareRule::setFareConditionText()
     * @uses FareRule::setRef()
     * @uses FareRule::setVoluntaryChangeCode()
     * @uses FareRule::setVoluntaryRefundCode()
     * @param \App|C\StructType\FareRuleDetails $details
     * @param \App|C\StructType\FareConditionText $fareConditionText
     * @param string $ref
     * @param string $voluntaryChangeCode
     * @param string $voluntaryRefundCode
     */
    public function __construct(\App|C\StructType\FareRuleDetails $details = null, \App|C\StructType\FareConditionText $fareConditionText = null, $ref = null, $voluntaryChangeCode = null, $voluntaryRefundCode = null)
    {
        $this
            ->setDetails($details)
            ->setFareConditionText($fareConditionText)
            ->setRef($ref)
            ->setVoluntaryChangeCode($voluntaryChangeCode)
            ->setVoluntaryRefundCode($voluntaryRefundCode);
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareRuleDetails|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareRuleDetails $details
     * @return \App|C\StructType\FareRule
     */
    public function setDetails(\App|C\StructType\FareRuleDetails $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get FareConditionText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareConditionText|null
     */
    public function getFareConditionText()
    {
        return isset($this->FareConditionText) ? $this->FareConditionText : null;
    }
    /**
     * Set FareConditionText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareConditionText $fareConditionText
     * @return \App|C\StructType\FareRule
     */
    public function setFareConditionText(\App|C\StructType\FareConditionText $fareConditionText = null)
    {
        if (is_null($fareConditionText) || (is_array($fareConditionText) && empty($fareConditionText))) {
            unset($this->FareConditionText);
        } else {
            $this->FareConditionText = $fareConditionText;
        }
        return $this;
    }
    /**
     * Get Ref value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRef()
    {
        return isset($this->Ref) ? $this->Ref : null;
    }
    /**
     * Set Ref value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ref
     * @return \App|C\StructType\FareRule
     */
    public function setRef($ref = null)
    {
        // validation for constraint: string
        if (!is_null($ref) && !is_string($ref)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ref, true), gettype($ref)), __LINE__);
        }
        if (is_null($ref) || (is_array($ref) && empty($ref))) {
            unset($this->Ref);
        } else {
            $this->Ref = $ref;
        }
        return $this;
    }
    /**
     * Get VoluntaryChangeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVoluntaryChangeCode()
    {
        return isset($this->VoluntaryChangeCode) ? $this->VoluntaryChangeCode : null;
    }
    /**
     * Set VoluntaryChangeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $voluntaryChangeCode
     * @return \App|C\StructType\FareRule
     */
    public function setVoluntaryChangeCode($voluntaryChangeCode = null)
    {
        // validation for constraint: string
        if (!is_null($voluntaryChangeCode) && !is_string($voluntaryChangeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($voluntaryChangeCode, true), gettype($voluntaryChangeCode)), __LINE__);
        }
        if (is_null($voluntaryChangeCode) || (is_array($voluntaryChangeCode) && empty($voluntaryChangeCode))) {
            unset($this->VoluntaryChangeCode);
        } else {
            $this->VoluntaryChangeCode = $voluntaryChangeCode;
        }
        return $this;
    }
    /**
     * Get VoluntaryRefundCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVoluntaryRefundCode()
    {
        return isset($this->VoluntaryRefundCode) ? $this->VoluntaryRefundCode : null;
    }
    /**
     * Set VoluntaryRefundCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $voluntaryRefundCode
     * @return \App|C\StructType\FareRule
     */
    public function setVoluntaryRefundCode($voluntaryRefundCode = null)
    {
        // validation for constraint: string
        if (!is_null($voluntaryRefundCode) && !is_string($voluntaryRefundCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($voluntaryRefundCode, true), gettype($voluntaryRefundCode)), __LINE__);
        }
        if (is_null($voluntaryRefundCode) || (is_array($voluntaryRefundCode) && empty($voluntaryRefundCode))) {
            unset($this->VoluntaryRefundCode);
        } else {
            $this->VoluntaryRefundCode = $voluntaryRefundCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
