<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefundRequestInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RefundRequestInfo
 * @subpackage Structs
 */
class RefundRequestInfo extends AbstractStructBase
{
    /**
     * The CreatedDateGMT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CreatedDateGMT;
    /**
     * The IsBookingLocked
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsBookingLocked;
    /**
     * Constructor method for RefundRequestInfo
     * @uses RefundRequestInfo::setCreatedDateGMT()
     * @uses RefundRequestInfo::setIsBookingLocked()
     * @param string $createdDateGMT
     * @param bool $isBookingLocked
     */
    public function __construct($createdDateGMT = null, $isBookingLocked = null)
    {
        $this
            ->setCreatedDateGMT($createdDateGMT)
            ->setIsBookingLocked($isBookingLocked);
    }
    /**
     * Get CreatedDateGMT value
     * @return string|null
     */
    public function getCreatedDateGMT()
    {
        return $this->CreatedDateGMT;
    }
    /**
     * Set CreatedDateGMT value
     * @param string $createdDateGMT
     * @return \App|C\StructType\RefundRequestInfo
     */
    public function setCreatedDateGMT($createdDateGMT = null)
    {
        // validation for constraint: string
        if (!is_null($createdDateGMT) && !is_string($createdDateGMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDateGMT, true), gettype($createdDateGMT)), __LINE__);
        }
        $this->CreatedDateGMT = $createdDateGMT;
        return $this;
    }
    /**
     * Get IsBookingLocked value
     * @return bool|null
     */
    public function getIsBookingLocked()
    {
        return $this->IsBookingLocked;
    }
    /**
     * Set IsBookingLocked value
     * @param bool $isBookingLocked
     * @return \App|C\StructType\RefundRequestInfo
     */
    public function setIsBookingLocked($isBookingLocked = null)
    {
        // validation for constraint: boolean
        if (!is_null($isBookingLocked) && !is_bool($isBookingLocked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isBookingLocked, true), gettype($isBookingLocked)), __LINE__);
        }
        $this->IsBookingLocked = $isBookingLocked;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\RefundRequestInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
