<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchFlightsForExchangeRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SearchFlightsForExchangeRequest
 * @subpackage Structs
 */
class SearchFlightsForExchangeRequest extends AbstractRequest
{
    /**
     * The AvailabilitySettings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AvailabilitySettings
     */
    public $AvailabilitySettings;
    /**
     * The FareDisplaySettings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareDisplayBaseSettings
     */
    public $FareDisplaySettings;
    /**
     * The OriginDestinations
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfOriginDestination
     */
    public $OriginDestinations;
    /**
     * The TicketFaresToExchange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfETTicketFareTarget
     */
    public $TicketFaresToExchange;
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\UniqueID
     */
    public $UniqueID;
    /**
     * The Verification
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Verification
     */
    public $Verification;
    /**
     * Constructor method for SearchFlightsForExchangeRequest
     * @uses SearchFlightsForExchangeRequest::setAvailabilitySettings()
     * @uses SearchFlightsForExchangeRequest::setFareDisplaySettings()
     * @uses SearchFlightsForExchangeRequest::setOriginDestinations()
     * @uses SearchFlightsForExchangeRequest::setTicketFaresToExchange()
     * @uses SearchFlightsForExchangeRequest::setUniqueID()
     * @uses SearchFlightsForExchangeRequest::setVerification()
     * @param \App|C\StructType\AvailabilitySettings $availabilitySettings
     * @param \App|C\StructType\FareDisplayBaseSettings $fareDisplaySettings
     * @param \App|C\ArrayType\ArrayOfOriginDestination $originDestinations
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange
     * @param \App|C\StructType\UniqueID $uniqueID
     * @param \App|C\StructType\Verification $verification
     */
    public function __construct(\App|C\StructType\AvailabilitySettings $availabilitySettings = null, \App|C\StructType\FareDisplayBaseSettings $fareDisplaySettings = null, \App|C\ArrayType\ArrayOfOriginDestination $originDestinations = null, \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange = null, \App|C\StructType\UniqueID $uniqueID = null, \App|C\StructType\Verification $verification = null)
    {
        $this
            ->setAvailabilitySettings($availabilitySettings)
            ->setFareDisplaySettings($fareDisplaySettings)
            ->setOriginDestinations($originDestinations)
            ->setTicketFaresToExchange($ticketFaresToExchange)
            ->setUniqueID($uniqueID)
            ->setVerification($verification);
    }
    /**
     * Get AvailabilitySettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AvailabilitySettings|null
     */
    public function getAvailabilitySettings()
    {
        return isset($this->AvailabilitySettings) ? $this->AvailabilitySettings : null;
    }
    /**
     * Set AvailabilitySettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AvailabilitySettings $availabilitySettings
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setAvailabilitySettings(\App|C\StructType\AvailabilitySettings $availabilitySettings = null)
    {
        if (is_null($availabilitySettings) || (is_array($availabilitySettings) && empty($availabilitySettings))) {
            unset($this->AvailabilitySettings);
        } else {
            $this->AvailabilitySettings = $availabilitySettings;
        }
        return $this;
    }
    /**
     * Get FareDisplaySettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareDisplayBaseSettings|null
     */
    public function getFareDisplaySettings()
    {
        return isset($this->FareDisplaySettings) ? $this->FareDisplaySettings : null;
    }
    /**
     * Set FareDisplaySettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareDisplayBaseSettings $fareDisplaySettings
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setFareDisplaySettings(\App|C\StructType\FareDisplayBaseSettings $fareDisplaySettings = null)
    {
        if (is_null($fareDisplaySettings) || (is_array($fareDisplaySettings) && empty($fareDisplaySettings))) {
            unset($this->FareDisplaySettings);
        } else {
            $this->FareDisplaySettings = $fareDisplaySettings;
        }
        return $this;
    }
    /**
     * Get OriginDestinations value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfOriginDestination|null
     */
    public function getOriginDestinations()
    {
        return isset($this->OriginDestinations) ? $this->OriginDestinations : null;
    }
    /**
     * Set OriginDestinations value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfOriginDestination $originDestinations
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setOriginDestinations(\App|C\ArrayType\ArrayOfOriginDestination $originDestinations = null)
    {
        if (is_null($originDestinations) || (is_array($originDestinations) && empty($originDestinations))) {
            unset($this->OriginDestinations);
        } else {
            $this->OriginDestinations = $originDestinations;
        }
        return $this;
    }
    /**
     * Get TicketFaresToExchange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfETTicketFareTarget|null
     */
    public function getTicketFaresToExchange()
    {
        return isset($this->TicketFaresToExchange) ? $this->TicketFaresToExchange : null;
    }
    /**
     * Set TicketFaresToExchange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setTicketFaresToExchange(\App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange = null)
    {
        if (is_null($ticketFaresToExchange) || (is_array($ticketFaresToExchange) && empty($ticketFaresToExchange))) {
            unset($this->TicketFaresToExchange);
        } else {
            $this->TicketFaresToExchange = $ticketFaresToExchange;
        }
        return $this;
    }
    /**
     * Get UniqueID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return isset($this->UniqueID) ? $this->UniqueID : null;
    }
    /**
     * Set UniqueID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\UniqueID $uniqueID
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setUniqueID(\App|C\StructType\UniqueID $uniqueID = null)
    {
        if (is_null($uniqueID) || (is_array($uniqueID) && empty($uniqueID))) {
            unset($this->UniqueID);
        } else {
            $this->UniqueID = $uniqueID;
        }
        return $this;
    }
    /**
     * Get Verification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Verification|null
     */
    public function getVerification()
    {
        return isset($this->Verification) ? $this->Verification : null;
    }
    /**
     * Set Verification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Verification $verification
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public function setVerification(\App|C\StructType\Verification $verification = null)
    {
        if (is_null($verification) || (is_array($verification) && empty($verification))) {
            unset($this->Verification);
        } else {
            $this->Verification = $verification;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SearchFlightsForExchangeRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
